// Variables
const llmHost = 'https://llm.vfsh.me';
const generateEndpoint = '/api/generate';

// Grab elements from the page
const userInput = document.getElementById('userInput');
const sendButton = document.getElementById('sendButton');
const outputArea = document.getElementById('outputArea');

// Functions
async function sendGen() {
    const response = await fetch(`${llmHost}${generateEndpoint}`, {
        method: 'POST',
        headers: {
            'Content-Type': 'application/json'
        },
        body: JSON.stringify({ model: 'llama3.2', prompt: userInput.value })
    });

    return response;
}

async function readResponse(response) {
    console.log(response);
    const reader = response.body.getReader();
    const decoder = new TextDecoder('utf-8');

    try {
        function read() {
            let finishedResponse = '';
            // Recursive function to read the stream
            reader.read().then(( chunk ) => {
                console.log(`Done: ${JSON.stringify(chunk.done)}`);
                console.log(`Value: ${new TextDecoder().decode(chunk.value)}`);
                if (chunk.value) {
                    const text = decoder.decode(chunk.value, { stream: true });
                    finishedResponse += text;
                    outputArea.innerHTML = finishedResponse;
                }
                if (chunk.done) {
                    return;
                }
                read();
            });
        }
        read();
    } catch (error) {
        outputArea.innerHTML = `<span class="text-red-500">Error: ${error.message}</span>`;
    }
}

// Event listeners
sendButton.addEventListener('click', async () => {
    outputArea.innerHTML = '';
    const response = await sendGen();
    readResponse(response);
});